Package com.io7m.jtensors.core.quaternions

# Class Quaternion4D

java.lang.Object
com.io7m.jtensors.core.quaternions.Quaternion4D

All Implemented Interfaces:
  `Quaternion4DType`, `QuaternionReadable4DType`

    public final class Quaternion4D
    extends java.lang.Object
    implements Quaternion4DType

The type of 4D `double`-typed quaternions.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type | Class | Description
  --- | --- | ---
  `static class` | `Quaternion4D.Builder` | Builds instances of type `Quaternion4D`.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `static Quaternion4D.Builder` | `builder()` | Creates a builder for `Quaternion4D`.
  `static Quaternion4D` | `copyOf​(Quaternion4DType instance)` | Creates an immutable copy of a `Quaternion4DType` value.
  `boolean` | `equals​(java.lang.Object another)` | This instance is equal to all instances of `Quaternion4D` that have equal attribute values.
  `int` | `hashCode()` | Computes a hash code from attributes: `x`, `y`, `z`, `w`.
  `static Quaternion4D` | `of​(double x, double y, double z, double w)` | Construct a new immutable `Quaternion4D` instance.
  `java.lang.String` | `toString()` | Prints the immutable value `Quaternion4D` with attribute values.
  `double` | `w()` |
  `Quaternion4D` | `withW​(double value)` | Copy the current immutable object by setting a value for the `w` attribute.
  `Quaternion4D` | `withX​(double value)` | Copy the current immutable object by setting a value for the `x` attribute.
  `Quaternion4D` | `withY​(double value)` | Copy the current immutable object by setting a value for the `y` attribute.
  `Quaternion4D` | `withZ​(double value)` | Copy the current immutable object by setting a value for the `z` attribute.
  `double` | `x()` |
  `double` | `y()` |
  `double` | `z()` |

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### x

    public double x()
    Specified by:
      `x` in interface `Quaternion4DType`
    Specified by:
      `x` in interface `QuaternionReadable4DType`
    Returns:
      The value of the `x` attribute

  - ### y

    public double y()
    Specified by:
      `y` in interface `Quaternion4DType`
    Specified by:
      `y` in interface `QuaternionReadable4DType`
    Returns:
      The value of the `y` attribute

  - ### z

    public double z()
    Specified by:
      `z` in interface `Quaternion4DType`
    Specified by:
      `z` in interface `QuaternionReadable4DType`
    Returns:
      The value of the `z` attribute

  - ### w

    public double w()
    Specified by:
      `w` in interface `Quaternion4DType`
    Specified by:
      `w` in interface `QuaternionReadable4DType`
    Returns:
      The value of the `w` attribute

  - ### withX

    public final Quaternion4D withX​(double value)
    Copy the current immutable object by setting a value for the `x` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for x
    Returns:
      A modified copy of the `this` object

  - ### withY

    public final Quaternion4D withY​(double value)
    Copy the current immutable object by setting a value for the `y` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for y
    Returns:
      A modified copy of the `this` object

  - ### withZ

    public final Quaternion4D withZ​(double value)
    Copy the current immutable object by setting a value for the `z` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for z
    Returns:
      A modified copy of the `this` object

  - ### withW

    public final Quaternion4D withW​(double value)
    Copy the current immutable object by setting a value for the `w` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for w
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals​(java.lang.Object another)
    This instance is equal to all instances of `Quaternion4D` that have equal attribute values.
    Overrides:
      `equals` in class `java.lang.Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `x`, `y`, `z`, `w`.
    Overrides:
      `hashCode` in class `java.lang.Object`
    Returns:
      hashCode value

  - ### toString

    public java.lang.String toString()
    Prints the immutable value `Quaternion4D` with attribute values.
    Overrides:
      `toString` in class `java.lang.Object`
    Returns:
      A string representation of the value

  - ### of

    public static Quaternion4D of​(double x, double y, double z, double w)
    Construct a new immutable `Quaternion4D` instance.
    Parameters:
      `x` - The value for the `x` attribute
      `y` - The value for the `y` attribute
      `z` - The value for the `z` attribute
      `w` - The value for the `w` attribute
    Returns:
      An immutable Quaternion4D instance

  - ### copyOf

    public static Quaternion4D copyOf​(Quaternion4DType instance)
    Creates an immutable copy of a `Quaternion4DType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable Quaternion4D instance

  - ### builder

    public static Quaternion4D.Builder builder()
    Creates a builder for `Quaternion4D`.

         Quaternion4D.builder()
            .setX(double) // required x
            .setY(double) // required y
            .setZ(double) // required z
            .setW(double) // required w
            .build();

    Returns:
      A new Quaternion4D builder